/* Gtk Widget Factory generated widget
 * http://gwf.sourceforge.net
 * Copyright (c) 1999-2000 Jeroen Benckhuijsen
*/

/* This file is Copyrighted (C) 1999-2000 by Jeroen Benckhuijsen (jfbenck@gwf.sourceforge.net)
 * Please read the license agreement below
*/

/*  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifdef HAVE_CONFIG
  #include <config.h>
#endif

#include <gtk/gtk.h>
#include <gwf_lib.h>
#include "gwf_errdlg.h"

static GtkObjectClass *parent_class = NULL;

static void	gwf_errdlg_class_init			    	(GwfErrdlgClass *klass);
static void	gwf_errdlg_init					(GwfErrdlg *errdlg);
static void	gwf_errdlg_destroy				(GtkObject *object);
static void	gwf_errdlg_interface				(GwfErrdlg *errdlg);
static void	on_buttonClear_clicked				(GtkButton *button,gpointer user_data);

guint
gwf_errdlg_get_type (void)
{
  static guint gwf_errdlg_type = 0;

  if (!gwf_errdlg_type)
    {
      GtkTypeInfo gwf_errdlg_info =
      {
        "GwfErrdlg",
        sizeof (GwfErrdlg),
        sizeof (GwfErrdlgClass),
        (GtkClassInitFunc) gwf_errdlg_class_init,
        (GtkObjectInitFunc) gwf_errdlg_init,
        /* reserved_1 */ NULL,
        /* reserved_2 */ NULL,
        (GtkClassInitFunc) NULL,
      };

      gwf_errdlg_type = gtk_type_unique (gtk_vbox_get_type (), &gwf_errdlg_info);
    }

  return gwf_errdlg_type;
}

static void
gwf_errdlg_class_init (GwfErrdlgClass *klass)
{
  GtkObjectClass *object_class;

  object_class = (GtkObjectClass*) klass;
  object_class->destroy = gwf_errdlg_destroy;
  parent_class = gtk_type_class (gtk_vbox_get_type());
}

static void
gwf_errdlg_init (GwfErrdlg *errdlg)
{
  errdlg->hint = gwf_gdkpixmap_create(GTK_WIDGET(errdlg),info_small_xpm);
  errdlg->warning = gwf_gdkpixmap_create(GTK_WIDGET(errdlg),warn_small_xpm);
  errdlg->error = gwf_gdkpixmap_create(GTK_WIDGET(errdlg),err_small_xpm);
}

static void
gwf_errdlg_destroy (GtkObject *object)
{
  gdk_pixmap_unref(GWF_ERRDLG(object)->hint);
  gdk_pixmap_unref(GWF_ERRDLG(object)->warning);
  gdk_pixmap_unref(GWF_ERRDLG(object)->error);

  parent_class->destroy(object);
}

GwfErrdlg*
gwf_errdlg_new(void)
{
  GwfErrdlg *errdlg;

  errdlg = GWF_ERRDLG( gtk_type_new ( gwf_errdlg_get_type()));
  gwf_errdlg_construct(errdlg);
  return errdlg;
}

void
gwf_errdlg_construct (GwfErrdlg *errdlg)
{
  gwf_errdlg_interface(errdlg);
}

void
gwf_errdlg_add_message(GwfErrdlg *errdlg,GwfErrType type,gchar *message)
{
  gchar		*text[2] = {NULL};
  gint		row;
  GtkAdjustment	*adj;

  g_return_if_fail(errdlg != NULL);
  g_return_if_fail(message != NULL);

  text[1] = message;
  row = gtk_clist_append(errdlg->errlist,text);

  switch (type)
  {
    case GWF_HINT    :	gtk_clist_set_pixmap(errdlg->errlist,row,0,errdlg->hint,NULL);
    			break;
    case GWF_WARNING :  gtk_clist_set_pixmap(errdlg->errlist,row,0,errdlg->warning,NULL);
    			break;
    case GWF_ERROR   :	gtk_clist_set_pixmap(errdlg->errlist,row,0,errdlg->error,NULL);
    			break;
    default           : g_warning("Invalid error type!");
    			break;
  }

  adj = gtk_scrolled_window_get_vadjustment(errdlg->scrollwin);
  gtk_adjustment_set_value(adj,adj->upper - adj->page_increment);
}

static void
gwf_errdlg_interface(GwfErrdlg *errdlg)
{
  GtkWidget *scrollwin;
  GtkWidget *clist;
  GtkWidget *hbox;
  GtkWidget *button;

  scrollwin = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrollwin);
  gtk_box_pack_start (GTK_BOX (errdlg), scrollwin, TRUE, TRUE, 0);
  errdlg->scrollwin = GTK_SCROLLED_WINDOW(scrollwin);

  clist = gtk_clist_new(2);
  errdlg->errlist = GTK_CLIST(clist);
  gtk_widget_show(clist);
  gtk_container_add (GTK_CONTAINER (scrollwin), clist);
  gtk_clist_set_column_width (GTK_CLIST (clist), 0, 40);
  gtk_clist_set_column_width (GTK_CLIST (clist), 1, 80);
  gtk_clist_set_row_height(GTK_CLIST(clist),20);

  hbox = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox);
  gtk_box_pack_start (GTK_BOX (errdlg), hbox, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (hbox), 2);

  button = gtk_button_new_with_label ("Clear");
  gtk_widget_show(button);
  gtk_box_pack_end (GTK_BOX (hbox), button, FALSE, FALSE, 0);

  gtk_signal_connect(GTK_OBJECT(button),"clicked",
                              GTK_SIGNAL_FUNC(on_buttonClear_clicked),
                              (gpointer)errdlg);
}

static void
on_buttonClear_clicked				(GtkButton		*button,
						 gpointer		user_data)
{
  GwfErrdlg		*errdlg = user_data;
  
  gtk_clist_clear(errdlg->errlist);
}
