/*  Gtk+ Widget Factory
 *  Copyright (C) 1999-2000  Jeroen Benckhuijsen
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifndef GWF_MAINWIN_H
#define GWF_MAINWIN_H

#ifdef __cplusplus
extern "C" {
#endif

#include <gtk/gtk.h>
#include <gwf_lib.h>
#include "gwf_window.h"
#include "gwf_errdlg.h"
#include "gwf_projtree.h"
#include "gwf_widprop.h"
#include "gwf_projopt.h"

#define GWF_MAINWIN(obj)		GTK_CHECK_CAST(obj, gwf_mainwin_get_type (), GwfMainWin )
#define GWF_MAINWIN_CLASS(klass)	GTK_CHECK_CLASS_CAST(klass, gwf_mainwin_get_type (), GwfMainWinClass)
#define GWF_IS_MAINWIN (obj)		GTK_CHECK_TYPE(obj, gwf_mainwin_get_type())

typedef struct _GwfMainWin 		GwfMainWin;
typedef struct _GwfMainWinClass		GwfMainWinClass;

struct _GwfMainWin
{
  GwfWindow		parent;
  
  gchar			*curprojname;

  GwfSettingsList	*settings;
  GwfXmlIO		*xmlio;
  GwfPluginList		*plugins;
  GwfTreeDataList	*treedatas;
  GwfSource		*source;
  GwfLicList		*liclist;
  GwfError		*error;

  GtkWidget		*aboutbox;
  GwfErrdlg		*errdlg;

  GwfProjOpt		*projopt;
  GwfWidProp		*widprop;
  GwfProjTree		*projtree;
  GtkWidget		*load_filesel;
  GtkWidget		*save_filesel;
};

struct _GwfMainWinClass
{
  GwfWindowClass	parent_class;

};

guint		gwf_mainwin_get_type 		(void);
GtkWidget*	gwf_mainwin_new			(GwfData *data);
void		gwf_mainwin_construct		(GwfMainWin *mainwin,GwfData *data);

#ifdef __cplusplus
}
#endif

#endif

