/*  Gtk+ Widget Factory
 *  Copyright (C) 1999-2000  Jeroen Benckhuijsen
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifndef GWF_WIDPROP_H
#define GWF_WIDPROP_H

#ifdef __cplusplus
extern "C" {
#endif

#include <gtk/gtk.h>
#include <gwf_lib.h>

#define GWF_WIDPROP(obj)		GTK_CHECK_CAST(obj, gwf_widprop_get_type (), GwfWidProp)
#define GWF_WIDPROP_CLASS(klass)	GTK_CHECK_CLASS_CAST(klass, gwf_widprop_get_type (), GwfWidPropClass)
#define GWF_IS_WIDPROP(obj)		GTK_CHECK_TYPE(obj, gwf_widprop_get_type())

typedef struct _GwfWidProp 		GwfWidProp;
typedef struct _GwfWidPropClass		GwfWidPropClass;

struct _GwfWidProp
{
  GtkVBox		parent;
  
  GtkNotebook		*nb;
  GwfProjlist		*projlist;
  GwfSettingsList	*list;
  gint			pages;
  gboolean		basicdone;
};

struct _GwfWidPropClass
{
  GtkVBoxClass		parent_class;

};

guint		gwf_widprop_get_type 		(void);
GtkWidget*	gwf_widprop_new			(GwfProjlist *projlist,GwfSettingsList *list);
void		gwf_widprop_construct 		(GwfWidProp *widprop,GwfProjlist *projlist,GwfSettingsList *list);

#ifdef __cplusplus
}
#endif

#endif

