/*  Gtk+ Widget Factory
 *  Copyright (C) 1999-2000  Jeroen Benckhuijsen
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifndef GWF_WIDPROPELEM_H
#define GWF_WIDPROPELEM_H

#ifdef __cplusplus
extern "C" {
#endif

#include <gtk/gtk.h>
#include <gwf_lib.h>

#define GWF_WIDPROP_ELEM(obj)		GTK_CHECK_CAST(obj, gwf_widpropelem_get_type (), GwfWidPropElem )
#define GWF_WIDPROP_ELEM_CLASS(klass)	GTK_CHECK_CLASS_CAST(klass, gwf_widpropelem_get_type (), GwfWidPropElemClass)
#define GWF_IS_WIDPROP_ELEM(obj)	GTK_CHECK_TYPE(obj, gwf_widpropelem_get_type())

typedef struct _GwfWidPropElem 		GwfWidPropElem;
typedef struct _GwfWidPropElemClass	GwfWidPropElemClass;

struct _GwfWidPropElem
{
  GtkVBox		parent;
  
  GtkCList		*elemlist;
  GtkEntry		*type;
  GtkEntry		*name;
  GtkEntry		*value;
  GtkToggleButton	*setfunc;
  GtkToggleButton	*allocset;
  GtkToggleButton	*getfunc;
  GtkToggleButton	*allocget;
  GtkText		*setcode;
  GtkText		*getcode;

  GdkPixmap		*item_set;

  GwfProjlist		*projlist;
};

struct _GwfWidPropElemClass
{
  GtkWindowClass	parent_class;

};

guint		gwf_widpropelem_get_type 		(void);
GtkWidget*	gwf_widpropelem_new			(GwfProjlist *projlist);
void		gwf_widpropelem_construct		(GwfWidPropElem *wpelem,GwfProjlist *projlist);

void		gwf_widpropelem_set_itemset		(GwfWidPropElem* wpelem,GdkPixmap *itemset);

#ifdef __cplusplus
}
#endif

#endif

